#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include<unistd.h>
#include<sys/ioctl.h>

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define MAGIC 'M'                       // The magic number.
#define SET_DATA _IOW(MAGIC,1u,int)     // The ioctl write command.
#define GET_DATA _IOR(MAGIC,2u,int)     // The ioctl read command.

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* The main function */
int main()							
{
	int fd;
	static unsigned int g = 0;
	static unsigned int h = 0;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* The open function */	
	fd = open("/dev/new_device", O_RDWR);				 	 
	if(fd < 0)
	{
		printf("Device file opened failed.\n");
		return -1;
	}
	else 
	{
		printf("The file opened successfully with fd as %d\n",fd);
	}

	printf("Type the integer data send to the driver :\n");
	scanf("%d",&g);

	if(ioctl(fd, SET_DATA,&g)<0)
	{
		printf("Ioctl function failed");
		return -1;

	}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* The ioctl function */

	if(ioctl(fd, GET_DATA,&h)<0)
	{
		printf("Ioctl function failed");
		return -1;
	}
	printf("The data get from the driver : %d\n",h);
	
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* The close function */
	close(fd);						
	printf("The device file is closed successfully with the fd: %d\n",fd);
	return 0;

}




